; $Id: dcs_sysdep.pro,v 1.3 2002/07/13 20:14:58 john Exp $
; Written by J.R.D. Copley.
;************************************************************************************************
pro dcs_sysdep,fonts=fonts,colors=colors
;************************************************************************************************
; This procedure defines the standard font, depending on the operating system.
;	In the future it may serve other purposes, depending on the operating system.
compile_opt strictarr
;
fonts=strarr(10)
colors=intarr(10)
;
case !VERSION.OS_FAMILY of
	"Windows": begin
		fonts[0]="TIMESROMAN*18"
		fonts[1]="courier*12"
		colors[0]=127
		end
	"unix": begin
		fonts[0]="lucidasans-12"
		fonts[1]="courier-12"
		colors[0]=60
		end
	"MacOS": begin
		x=dialog_message("Fonts and colors undefined in dcs_sysdep.pro",/warning)
		end
	else: stop,"Unsupported operating system."
endcase
;
end