;$Id: array_correct_dimension.pro,v 1.1 2002/04/23 23:09:04 jmspark Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
; Changes the dimensionality of an array to its mathematically correct value.
; For example, a 2 x 1 x 2 x 1 array is turned into a 2 x 2 array.
; Also, an one element array is changed into a scalar.
;
function array_correct_dimension $
	; INPUT
	, ptr

	*ptr = reform( *ptr )
	if n_elements( *ptr ) eq 1 then *ptr = (*ptr)[0]

	return, ptr

end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************