;$Id: scantype.pro,v 1.1 2002/04/23 14:47:01 jmspark Exp $


pro scantype,file_name,scan
;____________________________________________________________________
;|								    |
;| Purpose	: return which NIST icp buffer created the data     |
;|                file	    					    |
;|								    |
;|								    |
;| Input	: file_name, the file to be read		    |
;|								    |
;|__________________________________________________________________|

junk	=	''


openr,lun,file_name,/get_lun


;| read in header data for of the 1st line 	|


	; Read the file
	readf,lun,junk

	; Remove the leading & the trailing blanks.
	junk		=	strtrim(junk,2)

	; Pick up the 36th character.
	scan		=	strmid(junk,36,1)

	; Close the file.
	free_lun,lun

end

